Build UNSIGNED transaction(s) to fund a leg — sign with your own key/HSM, then broadcast
curl --request POST \
--url https://api.hashlock.markets/v1/swaps/{id}/legs/{leg}/fund \
--header 'Authorization: Bearer <token>'import requests
url = "https://api.hashlock.markets/v1/swaps/{id}/legs/{leg}/fund"
headers = {"Authorization": "Bearer <token>"}
response = requests.post(url, headers=headers)
print(response.text)const options = {method: 'POST', headers: {Authorization: 'Bearer <token>'}};
fetch('https://api.hashlock.markets/v1/swaps/{id}/legs/{leg}/fund', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.hashlock.markets/v1/swaps/{id}/legs/{leg}/fund",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"net/http"
"io"
)
func main() {
url := "https://api.hashlock.markets/v1/swaps/{id}/legs/{leg}/fund"
req, _ := http.NewRequest("POST", url, nil)
req.Header.Add("Authorization", "Bearer <token>")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.hashlock.markets/v1/swaps/{id}/legs/{leg}/fund")
.header("Authorization", "Bearer <token>")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.hashlock.markets/v1/swaps/{id}/legs/{leg}/fund")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
response = http.request(request)
puts response.read_body{
"chain": "<string>",
"family": "evm",
"sign": "evm-tx",
"note": "<string>",
"chainId": 123,
"from": "<string>",
"txs": [
{
"to": "<string>",
"data": "<string>",
"value": "<string>"
}
],
"payTo": "<string>",
"amountSats": "<string>",
"topUp": true,
"feePayTo": "<string>",
"feeAmountSats": "<string>",
"toAddress": "<string>",
"psbtBase64": "<string>",
"sighashHex": "<string>",
"sighashHexes": [
"<string>"
],
"feeSats": 123,
"preimageHex": "<string>",
"timelockUnix": 123,
"escrow": "<string>",
"transactionBase64": "<string>",
"blockhash": "<string>",
"lastValidBlockHeight": 123,
"transactions": [
{
"transaction": {},
"txID": "<string>"
}
]
}{
"error": "<string>"
}{
"error": "<string>"
}{
"error": "<string>"
}{
"error": "<string>"
}Swaps and settlement
Build UNSIGNED transaction(s) to fund a leg — sign with your own key/HSM, then broadcast
EVM: sign every returned transaction from the returned from address — the leg refund address. The factory refuses any other sender, and the escrow refunds to it.
POST
/
v1
/
swaps
/
{id}
/
legs
/
{leg}
/
fund
Build UNSIGNED transaction(s) to fund a leg — sign with your own key/HSM, then broadcast
curl --request POST \
--url https://api.hashlock.markets/v1/swaps/{id}/legs/{leg}/fund \
--header 'Authorization: Bearer <token>'import requests
url = "https://api.hashlock.markets/v1/swaps/{id}/legs/{leg}/fund"
headers = {"Authorization": "Bearer <token>"}
response = requests.post(url, headers=headers)
print(response.text)const options = {method: 'POST', headers: {Authorization: 'Bearer <token>'}};
fetch('https://api.hashlock.markets/v1/swaps/{id}/legs/{leg}/fund', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.hashlock.markets/v1/swaps/{id}/legs/{leg}/fund",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"net/http"
"io"
)
func main() {
url := "https://api.hashlock.markets/v1/swaps/{id}/legs/{leg}/fund"
req, _ := http.NewRequest("POST", url, nil)
req.Header.Add("Authorization", "Bearer <token>")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.hashlock.markets/v1/swaps/{id}/legs/{leg}/fund")
.header("Authorization", "Bearer <token>")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.hashlock.markets/v1/swaps/{id}/legs/{leg}/fund")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
response = http.request(request)
puts response.read_body{
"chain": "<string>",
"family": "evm",
"sign": "evm-tx",
"note": "<string>",
"chainId": 123,
"from": "<string>",
"txs": [
{
"to": "<string>",
"data": "<string>",
"value": "<string>"
}
],
"payTo": "<string>",
"amountSats": "<string>",
"topUp": true,
"feePayTo": "<string>",
"feeAmountSats": "<string>",
"toAddress": "<string>",
"psbtBase64": "<string>",
"sighashHex": "<string>",
"sighashHexes": [
"<string>"
],
"feeSats": 123,
"preimageHex": "<string>",
"timelockUnix": 123,
"escrow": "<string>",
"transactionBase64": "<string>",
"blockhash": "<string>",
"lastValidBlockHeight": 123,
"transactions": [
{
"transaction": {},
"txID": "<string>"
}
]
}{
"error": "<string>"
}{
"error": "<string>"
}{
"error": "<string>"
}{
"error": "<string>"
}Authorizations
Response
chain-specific signing material (EVM txs / BTC pay-to / TRON txs / Solana transaction, base64)
What to sign, per chain family; sign says which shape it is. evm-tx: sign and send each of txs in order, from from when given. btc-payment (fund): pay amountSats to payTo (and feeAmountSats to feePayTo when present). btc-sighash (claim/refund): sign each of sighashHexes, then broadcast { psbtBase64, signaturesHex, preimageHex? }. solana-tx: sign transactionBase64 and broadcast it. tron-txid: sign each transactions[].txID and broadcast each signed transaction.